//
//  ivAppObjAlgoMakeObject.h
//  Interactive Videos: Plausible Video Editing using Sparse Structure Points
//
//  Created by Chia-Sheng Chang on 03/01/16.
//  Copyright (c) 2016 Chia-Sheng Chang. All rights reserved.
//

#ifndef __ivManipulation__ivAppObjAlgoMakeObject__
#define __ivManipulation__ivAppObjAlgoMakeObject__

#import "ivAppObjAlgorithm.h"

#import "ivAppGuiParams.h"
#import "lsqSparseToDenseMap.h"

class ivAppObjAlgoMakeObject : public ivAppObjAlgorithm
{
private:
    //calc dense object depth map / diffuse intensity map
    void interpolateAttributeMaps
    (const ivAppObject *obj, const cv::Rect &objBB,
     cv::Mat &depthMap, cv::Mat &diffuseMap);
    
    //adjust object intensity
    void adjustObjectIntensity
    (ivAppObject *obj, cv::Mat &objDiffuse);
    
public:
    virtual bool execute(ivAppObject *obj);
};

#endif /* defined(__ivManipulation__ivAppObjAlgoMakeObject__) */
