//
//  ivAppObjAlgoMakeShadow.h
//  Interactive Videos: Plausible Video Editing using Sparse Structure Points
//
//  Created by Chia-Sheng Chang on 03/01/16.
//  Copyright (c) 2016 Chia-Sheng Chang. All rights reserved.
//

#ifndef __ivManipulation__ivAppObjAlgoMakeShadow__
#define __ivManipulation__ivAppObjAlgoMakeShadow__

#import "ivAppObjAlgorithm.h"

#import "lsqSparseToDenseMap.h"

class ivAppObjAlgoMakeShadow : public ivAppObjAlgorithm
{
private:
    //calc toObj Distance and adjust shadow intensity
    void applyShadowIntensity(cv::Mat &shadowMask, cv::Rect &shdBB, ivAppObject *obj);
    
    //calc dense shadow blurring weight and apply it to shadow patch
    void applyShadowBlurring(cv::Mat &shadowMask, cv::Rect &shdBB, ivAppObject *obj);
    
public:
    virtual bool execute(ivAppObject *obj);
};

#endif /* defined(__ivManipulation__ivAppObjAlgoMakeShadow__) */
