//
//  ivAppObjAlgoSetFrame.mm
//  Interactive Videos: Plausible Video Editing using Sparse Structure Points
//
//  Created by Chia-Sheng Chang on 03/01/16.
//  Copyright (c) 2016 Chia-Sheng Chang. All rights reserved.
//

#include "ivAppObjAlgoSetFrame.h"

bool ivAppObjAlgoSetFrame::execute(ivAppObject *obj)
{
    ivAppGuiParams *guiParams = [ivAppGuiParams instance];
    
    ivAppObjectData &objData = obj->objData;
    ivAppObjectFrameData &objFrameData = objData.frames.back();
    const int clusterNum = (int)objData.parts.size();
    for(int i=0;i<clusterNum;i++)
    {
        ObjShdWarpData &oswData = objFrameData[i];
        oswData.object.nfData = objData.objNFrames( i, guiParams.aniPos );
        oswData.shadow.nfData = objData.shdNFrames( i, guiParams.aniPos );
    }
    
    return true;
}