//
//  ivAppObjAlgoSetup.mm
//  Interactive Videos: Plausible Video Editing using Sparse Structure Points
//
//  Created by Chia-Sheng Chang on 03/01/16.
//  Copyright (c) 2016 Chia-Sheng Chang. All rights reserved.
//

#include "ivAppObjAlgoSetup.h"

bool ivAppObjAlgoSetup::execute(ivAppObject *obj)
{
    ivAppGuiParams *guiParams = [ivAppGuiParams instance];
    const ivAppScene &scene = ivAppScene::instance();
    ivAppObjectFrameData &objFrameData = obj->objData.frames.back();
    
    //reset data
    objFrameData.resetData();
    
    //initializate the params
    objFrameData.gTransform = obj->objAnimation.objPose.gTransform();
    objFrameData.gTransformInv = objFrameData.gTransform.inverse();
    objFrameData.cameraPos_obj = objFrameData.gTransformInv * scene.scnSfM.vFrameData[guiParams.scnPos].camPosition;
    objFrameData.lightPos_obj  = objFrameData.gTransformInv * scene.scnLight.pos;
    objFrameData.prjM_scn = scene.scnSfM.vFrameData[guiParams.scnPos].KM;
    
    return true;
}
