//
//  ivAppObjAlgoUseNewFrameData.mm
//  Interactive Videos: Plausible Video Editing using Sparse Structure Points
//
//  Created by Chia-Sheng Chang on 03/01/16.
//  Copyright (c) 2016 Chia-Sheng Chang. All rights reserved.
//

#include "ivAppObjAlgoUseNewFrameData.h"

bool ivAppObjAlgoUseNewFrameData::execute(ivAppObject *obj)
{
    const ivAppObjParams &objParams = obj->objParams;
    int CLG_tm_fnum  = objParams.CLG_tm_fnum;
    
    ivAppObjectData &objData = obj->objData;
    
    //remove unrelated framedata
    if( CLG_tm_fnum+1 <= (int)objData.frames.size() )
        objData.frames.pop_front();
    
    //new frame data
    objData.frames.push_back( ivAppObjectFrameData() );
    objData.initCurrentFrameData(false);
    
    return true;
}