//
//  ivAppObjAlgoClusterNearestFrames.h
//  Interactive Videos: Plausible Video Editing using Sparse Structure Points
//
//  Created by Chia-Sheng Chang on 03/01/16.
//  Copyright (c) 2016 Chia-Sheng Chang. All rights reserved.
//

#ifndef __ivManipulation__ivAppObjAlgoClusterNearestFrames__
#define __ivManipulation__ivAppObjAlgoClusterNearestFrames__

#import "ivAppObjAlgorithm.h"

#import "ivAppObjAlgoSetup.h"
#import "ivAppGuiParams.h"
#import "ivRenderOrder.h"

class ivAppObjAlgoClusterNearestFrame : public ivAppObjAlgorithm
{
public:
    static void calcOriDiff(std::vector<float> &oriDiffs,
                            const std::vector<int> &cluster,
                            const Eigen::Vector4f &c_obj_target,
                            const ivAppSfM &objSfM );
protected:
    float FindNearest
    (int &nframeID, const std::vector<int> &cluster,
     const Eigen::Vector4f &c_obj_target, const ivAppSfM &objSfM );

public:
    virtual bool execute(ivAppObject *obj);
};

class ivAppObjAlgoClusterNearestFrames : public ivAppObjAlgoClusterNearestFrame
{
public:
    virtual bool execute(ivAppObject *obj);
};

#endif /* defined(__ivManipulation__ivAppObjAlgoClusterNearestFrames__) */
