//
//  ivAppObjAlgorithm.h
//  Interactive Videos: Plausible Video Editing using Sparse Structure Points
//
//  Created by Chia-Sheng Chang on 03/01/16.
//  Copyright (c) 2016 Chia-Sheng Chang. All rights reserved.
//

#ifndef __ivManipulation__ivAppObjAlgorithm__
#define __ivManipulation__ivAppObjAlgorithm__

#import "Utils_Timer.h"
#import "ivAppObject.h"

//interface of algorithms
class ivAppObjAlgorithm
{
protected:
    //constructor
    ivAppObjAlgorithm(){}
    
public:
    //destructor
    virtual ~ivAppObjAlgorithm(){}
    
    //execute the process
    virtual bool execute(ivAppObject *obj) = 0;
    
    //the description of the process
    virtual std::string toString();
};

class ivAppObjAlgorithmList : public std::list<ivAppObjAlgorithm*>
{
public:
    //execute the process
    bool execute(ivAppObject *obj, std::string processName, bool useTimer);
    
    //release
    void release();
};

#endif /* defined(__ivManipulation__ivAppObjAlgorithm__) */
