//
//  ivAppObjAlgoCBFNF.cpp
//  Interactive Videos: Plausible Video Editing using Sparse Structure Points
//
//  Created by Chia-Sheng Chang on 03/01/16.
//  Copyright (c) 2016 Chia-Sheng Chang. All rights reserved.
//

#include "ivAppObjAlgoCBFNF.h"

ivAppObjAlgoCBFNF ivAppObjAlgoCBFNF::inst;

//execute the process
bool ivAppObjAlgoCBFNF::execute(ivAppObject *obj, bool useSelectedFrames)
{
    if( !obj->isReady )
        return false;
    
    ivAppObjAlgorithmList algoList;
    
    //1. setup
    algoList.push_back( new ivAppObjAlgoSetup );
    
    //2. find nearest frames
    if( !useSelectedFrames )
        algoList.push_back( new ivAppObjAlgoClusterNearestFrame );
    else
        algoList.push_back( new ivAppObjAlgoSetFrame );
    
    //3. check frame
    algoList.push_back( new ivAppObjAlgoCheckFrame );
    
    //4. prepare points
    algoList.push_back( new ivAppObjAlgoPreparePoints );
    
    //5. prepare edges
    algoList.push_back( new ivAppObjAlgoPrepareEdges );
    
    //execution
    algoList.execute(obj, "CBFNF", false);

    //delete
    algoList.release();
    
    return true;
}