//
//  ivAppObjAlgoMain.h
//  Interactive Videos: Plausible Video Editing using Sparse Structure Points
//
//  Created by Chia-Sheng Chang on 03/01/16.
//  Copyright (c) 2016 Chia-Sheng Chang. All rights reserved.
//

#ifndef __ivManipulation__ivAppObjAlgoMain__
#define __ivManipulation__ivAppObjAlgoMain__

#import "ivAppObjAlgoFrontGraphCutFrames.h"

#import "ivAppObjAlgoUseNewFrameData.h"
#import "ivAppObjAlgoSetup.h"
#import "ivAppObjAlgoSetFrame.h"
#import "ivAppObjAlgoPreparePoints.h"
#import "ivAppObjAlgoPrepareEdges.h"
#import "ivAppObjAlgoSetWarps.h"
#import "ivAppObjAlgoCoGEPWarping.h"
#import "ivAppObjAlgoCalcMotionField.h"
#import "ivAppObjAlgoAddShadowConstraints.h"
#import "ivAppObjAlgoCollage.h"
#import "ivAppObjAlgoMakeObject.h"
#import "ivAppObjAlgoMakeShadow.h"

class ivAppObjAlgoMain
{
private:
    ivAppObjAlgoMain(){}
    ~ivAppObjAlgoMain(){}
    ivAppObjAlgoMain(const ivAppObjAlgoMain&);
    ivAppObjAlgoMain& operator=(const ivAppObjAlgoMain&);
    static ivAppObjAlgoMain inst;
    
public:
    static ivAppObjAlgoMain& instance(){return inst;}
    
    //execute the process
    bool execute(ivAppObject *obj, bool useSelectedFrames, bool isFirstPose);
};

#endif /* defined(__ivManipulation__ivAppObjAlgoMain__) */
