//
//  ivAppObjAlgoPreProcess.h
//  Interactive Videos: Plausible Video Editing using Sparse Structure Points
//
//  Created by Chia-Sheng Chang on 03/01/16.
//  Copyright (c) 2016 Chia-Sheng Chang. All rights reserved.
//

#ifndef __ivManipulation__ivAppObjAlgoPreProcess__
#define __ivManipulation__ivAppObjAlgoPreProcess__

#import "ivAppObjAlgorithm.h"
#import "ivAppObjAlgoNormalEstimation.h"
#import "ivAppObjAlgoClustering.h"
#import "ivAppObjAlgoEdgeClassification.h"
#import "ivAppObjAlgoBuildSimGraph.h"
#import "ivAppGuiParams.h"

class ivAppObjAlgoPreProcess
{
private:
    ivAppObjAlgoPreProcess(){}
    ~ivAppObjAlgoPreProcess(){}
    ivAppObjAlgoPreProcess(const ivAppObjAlgoPreProcess&);
    ivAppObjAlgoPreProcess& operator=(const ivAppObjAlgoPreProcess&);
    static ivAppObjAlgoPreProcess inst;
    
public:
    static ivAppObjAlgoPreProcess& instance(){return inst;}
    
    //1. build sim graph
    //2. normal estimation
    //3. clustering
    //4. edge classification
    bool execute(ivAppObject *obj);
};

#endif /* defined(__ivManipulation__ivAppObjAlgoNECEC__) */
