//
//  ivAppObjAlgoSelectFrames.mm
//  Interactive Videos: Plausible Video Editing using Sparse Structure Points
//
//  Created by Chia-Sheng Chang on 03/01/16.
//  Copyright (c) 2016 Chia-Sheng Chang. All rights reserved.
//

#include "ivAppObjAlgoSelectFrames.h"

ivAppObjAlgoSelectFrames ivAppObjAlgoSelectFrames::inst;

bool ivAppObjAlgoSelectFrames::execute(ivAppObject *obj)
{
    if( !obj->isReady )
        return false;
    
    ivAppObjAlgorithmList algoList;
    
    //find nearest frames
    algoList.push_back( new ivAppObjAlgoFrontGraphCutFrames );
    
    //check frame
    algoList.push_back( new ivAppObjAlgoCheckFrames );
    
    //execution
    algoList.execute(obj, "SelectFrames", true);
    
    //delete
    algoList.release();
    
    return true;
}