//
//  ivAppObjectSfMSimGraph.h
//  Interactive Videos: Plausible Video Editing using Sparse Structure Points
//
//  Created by Chia-Sheng Chang on 03/01/16.
//  Copyright (c) 2016 Chia-Sheng Chang. All rights reserved.
//

#ifndef __ivManipulation__ivAppObjectSfMSimGraph__
#define __ivManipulation__ivAppObjectSfMSimGraph__

#include "ivAppSfM.h"
#include "ivDirParams.h"

class ivAppObjectSfMSimGraph
{
private:
    Eigen::MatrixXf simGraphMatrix;
    float OSG_oriDiff;//orientation difference
    int OSG_frmT;   //frame threshold
    
public:
    //build similarity graph
    void buildSimGraph(const ivAppSfM &objSfM,
                       float OSG_oriDiff, int OSG_frmT);
    
    //if i, j are neighbor
    bool isNeighbor(int i, int j)const;
    
    //get the error from i to j
    float operator()(int i, int j)const;
};

#endif /* defined(__ivManipulation__ivAppObjectSfMSimGraph__) */
