//
//  ivAppObjectVideo.h
//  Interactive Videos: Plausible Video Editing using Sparse Structure Points
//
//  Created by Chia-Sheng Chang on 03/01/16.
//  Copyright (c) 2016 Chia-Sheng Chang. All rights reserved.
//

#ifndef __ivManipulation__ivAppObjectVideo__
#define __ivManipulation__ivAppObjectVideo__

#include "ivDirParams.h"
#include "ivAppVideo.h"
#include "ivAppSfM.h"
#include "Utils_Ocv.h"

#define BORDER_SZ 10

class ivAppObjectVideo
{
private:
    //object fg region with border
    std::vector<cv::Rect> objROIs;
    
    //contour region map
    std::vector<cv::Mat> objCntrMasks;
    
public:
    bool isReady;
    
    //object video
    ivAppVideo objVideo;
    
    //object mask
    ivAppVideo objMask;
    
    //initialization
    void init(std::string tcName);
    
    //crop object region
    void getFGRegion(cv::Mat &img, int nframeID) const;
    
    //map point to roi space
    bool remapPoint(cv::Point2f &p, int nframeID) const;
    
    //check if the point is near the contour
    bool isNearContour(const cv::Point2f &p, int nframeID) const;
};

#endif /* defined(__ivManipulation__ivAppObjectVideo__) */
