//
//  ivRenderOrder.h
//  Interactive Videos: Plausible Video Editing using Sparse Structure Points
//
//  Created by Chia-Sheng Chang on 03/01/16.
//  Copyright (c) 2016 Chia-Sheng Chang. All rights reserved.
//

#ifndef __ivManipulation__ivRenderOrder__
#define __ivManipulation__ivRenderOrder__

#import "ivAppGuiParams.h"
#import "ivAppScene.h"
#import "ivAppObjects.h"

class scnobjPose
{
public:
    scnobjPose(int scenePose, int objPose)
    {
        this->scenePose = scenePose;
        this->objPose = objPose;
    }
    
    int scenePose;
    int objPose;
};

class ivRenderOrder
{
private:
    ivRenderOrder(){}
    ~ivRenderOrder(){}
    ivRenderOrder(const ivRenderOrder&);
    ivRenderOrder& operator=(const ivRenderOrder&);
    static ivRenderOrder inst;
    
public:
    static ivRenderOrder& instance(){return inst;}

    //rendering order table
    std::vector<scnobjPose> ROT;
    
    //calculate Rendering Order Table
    void calcROT();
    
    //set animation pose
    void setAnimationPose()const;
    
    //get the max pose
    int getMaxPos();
};

#endif /* defined(__ivManipulation__ivRenderOrder__) */
