//
//  ivAppLight.cpp
//  Interactive Videos: Plausible Video Editing using Sparse Structure Points
//
//  Created by Chia-Sheng Chang on 03/01/16.
//  Copyright (c) 2016 Chia-Sheng Chang. All rights reserved.
//

#include "ivAppLight.h"

ivAppLight::ivAppLight()
{
    this->lightIntensity = 1.0f;
    this->pos << 0.0f, 0.0f, 3.0f, 1.0f;
}

void ivAppLight::render()
{
    glColor3f(lightIntensity, lightIntensity, lightIntensity);
    
    glPushMatrix();
    glTranslatef(pos(0),pos(1),pos(2));
    glScalef(0.05, 0.05, 0.05);
    Utils_Ogl::drawSphere(10,10);
    glPopMatrix();
    
    //render the manipulation guidance
    glPushAttrib(GL_LINE_BIT);
    glLineWidth(4);
    
    glBegin(GL_LINE_STRIP);
    glVertex3f(pos(0),pos(1),pos(2));
    glVertex3f(pos(0),pos(1),0.0f);
    glVertex3f(0.0f,0.0f,0.0f);
    glEnd();
    
    glPopAttrib();
}

//io
std::istream& operator>>(std::istream& is, ivAppLight& light)
{
    std::string trash;
    is >> trash;
    is >> trash >> light.lightIntensity;
    is >> trash >> light.pos(0) >> light.pos(1) >> light.pos(2) >> light.pos(3);
    return is;
}

std::ostream& operator<<(std::ostream& os, const ivAppLight& light)
{
    os << "Light:" << std::endl;
    os << "\tlightIntensity: " << light.lightIntensity  << std::endl;
    os << "\tlightPosition:  " << light.pos.transpose() << std::endl;
    return os;
}
