//
//  ivAppScene.h
//  Interactive Videos: Plausible Video Editing using Sparse Structure Points
//
//  Created by Chia-Sheng Chang on 03/01/16.
//  Copyright (c) 2016 Chia-Sheng Chang. All rights reserved.
//

#ifndef __ivManipulation__ivAppScene__
#define __ivManipulation__ivAppScene__

#import "ivDirParams.h"
#import "ivAppVideo.h"
#import "ivAppSfM.h"
#import "ivAppLight.h"
#import "ivAppGuiParams.h"

class ivAppScene
{
private:
    ivAppScene():isReady(false){}
    ~ivAppScene(){}
    ivAppScene(const ivAppScene &);
    ivAppScene& operator=(const ivAppScene&);
    static ivAppScene inst;

public:
    static ivAppScene& instance(){return inst;}

    bool isReady;
    
    //name of the scene
    std::string tcName;

    //data of the scene
    ivAppVideo scnVideo;
    ivAppSfM scnSfM;
    ivAppLight scnLight;
    
    //depth map of the gorun
    cv::Mat groundDepthMap;
    
    //initialization
    void init( std::string tcName );
    
    //estimate ground depth
    void estimateGroundDepth();

    //io
    friend std::istream& operator>>(std::istream& is, ivAppScene& scene);
    friend std::ostream& operator<<(std::ostream& os, const ivAppScene& scene);
};

#endif /* defined(__ivManipulation__ivAppScene__) */
