//
//  ivAppGuiParams.h
//  Interactive Videos: Plausible Video Editing using Sparse Structure Points
//
//  Created by Chia-Sheng Chang on 03/01/16.
//  Copyright (c) 2016 Chia-Sheng Chang. All rights reserved.
//

#import "ivDirParams.h"
#import "Utils_DirList.h"

#ifndef __ivManipulation__ivAppGuiParams__
#define __ivManipulation__ivAppGuiParams__

#define OSZ_WIDTH 640
#define OSZ_HEIGHT 360

//singleton
@interface ivAppGuiParams : NSObject
{
@public
    //rendering name/states
    NSMutableDictionary *rStates;
}

//rendering states tableview
#pragma mark Renderint States
@property (retain) IBOutlet NSTableView *tableview_rState;
-(void)setRState_ObjectPreview;
-(void)setRState_ObjectCollageEdge;
-(void)setRState_ObjectCollageFeature;
-(void)setRState_ObjectCollage;
-(void)setRState_Manipulation;
-(void)setRState_Structure;
-(void)setRState_Results;

-(void)reset;

+ (id)instance;

//manipulation mode object/light/manipulatioin guidance
@property int mMode;

//animation pose
@property int scnPos;
@property int scnMaxPos;
@property int objPos;
@property int objMaxPos;
@property int aniPos;
@property int aniMaxPos;
@property int aniType;

//input video list
@property (retain) NSMutableArray *sceneList;
@property (retain) NSMutableArray *objectList;

//the selected test case
@property (copy) NSString* selectedScene;
@property (copy) NSString* selectedObject;

@end


#endif