//
//  ivAppGodViewRenderer.h
//  Interactive Videos: Plausible Video Editing using Sparse Structure Points
//
//  Created by Chia-Sheng Chang on 03/01/16.
//  Copyright (c) 2016 Chia-Sheng Chang. All rights reserved.
//

#ifndef __ivManipulation__ivAppGodView__
#define __ivManipulation__ivAppGodView__

#import "ivAppGuiParams.h"
#import "ivAppScene.h"
#import "ivAppObjects.h"
#import "ivRenderOrder.h"

class ivAppGodView
{
private:
    ivAppGodView(){this->reset();}
    ~ivAppGodView(){}
    ivAppGodView(const ivAppGodView &);
    ivAppGodView& operator=(const ivAppGodView&);
    static ivAppGodView inst;
    
    //sub rendering functions
    void drawObjectData();
    void drawAnimationData();
    void drawSelectedFrameCameras();
    void drawCurrentState();
    
public:
    static ivAppGodView& instance(){return inst;}
    
    //viewing camera
    float targetScale;
    float alpha;
    float beta;
    
    //rendering option
    bool srcAxis;
    bool motionAxis;
    
    //reset the above params
    void reset();
    
    //draw the object god view
    void drawGodView();
    
    //io
    friend std::istream& operator>>(std::istream& is, ivAppGodView& scene);
    friend std::ostream& operator<<(std::ostream& os, const ivAppGodView& scene);
};

#endif /* defined(__ivManipulation__ivAppGodViewRenderer__) */
