//
//  ivAppDriver.h
//  Interactive Videos: Plausible Video Editing using Sparse Structure Points
//
//  Created by Chia-Sheng Chang on 03/01/16.
//  Copyright (c) 2016 Chia-Sheng Chang. All rights reserved.
//

#import "ivDirParams.h"
#import "ivAppGuiParams.h"
#import "ivAppRenderer.h"
#import "ivRenderOrder.h"
#import "ivAppScene.h"
#import "ivAppObjects.h"
#import "Utils_Ogl.h"
#import "ivAppGodView.h"

#import "ivAppObjAlgoPreProcess.h"
#import "ivAppObjAlgoSelectFrames.h"
#import "ivAppObjAlgoMain.h"
#import "Utils_Timer.h"

@interface ivAppDriver : NSObject
{
    
}
+ (id)instance;

#pragma mark - Property

//object params tableview
@property (retain) IBOutlet NSTableView *tableview_Patameters;

#pragma mark - View Call Back

//setup animation
-(void)setupAnimation;

//set animation pose
-(void)setObjPose;
-(void)setAniPose;

//switch to the scene
-(void)gotoScene;

//modify object list
-(void)addObject;
-(void)rmCurObject;
-(void)duplicateObject;
-(void)nextObject;
-(void)prevObject;

//reset the object
-(void)resetObject;

//preprocess object
-(void)preProcessObj;

//select frames
-(void)selectFrames;

//process
-(void)process;

#pragma mark - Menu Call Back

// Render : set rendering mode
-(void)setRState_Manipulation;
-(void)setRState_Structure;
-(void)setRState_Results;

#pragma mark - Exporting
-(void)captureImage:(std::string)imgPath chnNum:(int)cn;
-(void)exportVideo:(std::string)videoPath FPS:(double)fps;

#pragma mark - Mouse Call Back

//drag the mouse
- (void)dragCallBack:(NSPoint)tgtPoint;

//2 fingers scroll
- (void)scrollCallBack:(NSEvent *)theEvent;

//scalling
- (void)zoomInOutCallBack:(NSEvent *)theEvent;

#pragma mark - Keyboard Call Back

//keyboard call back function
- (void) keyDownCallBack:(NSEvent *)theEvent;
- (void) keyUpCallBack:(NSEvent *)theEvent;

@end
