//
//  ivAppRStates.mm
//  Interactive Videos: Plausible Video Editing using Sparse Structure Points
//
//  Created by Chia-Sheng Chang on 03/01/16.
//  Copyright (c) 2016 Chia-Sheng Chang. All rights reserved.
//

#import "ivAppRStates.h"

@implementation ivAppRStates

- (NSInteger)numberOfRowsInTableView:(NSTableView *)tableView
{
    ivAppGuiParams *guiParams = [ivAppGuiParams instance];
    return [guiParams->rStates count];
}

- (id)tableView:(NSTableView *)tableView objectValueForTableColumn:(NSTableColumn *)tableColumn row:(NSInteger)row
{
    ivAppGuiParams *guiParams = [ivAppGuiParams instance];
    NSArray *keys = [[guiParams->rStates allKeys] sortedArrayUsingSelector: @selector(compare:)];
    
    if ([[tableColumn identifier] isEqualTo:@"name"])
        return [keys objectAtIndex:row];
    else if ([[tableColumn identifier] isEqualTo:@"state"])
        return [guiParams->rStates objectForKey:[keys objectAtIndex:row]];
    
    return 0;
}

- (void)tableView:(NSTableView *)tableView setObjectValue:(id)value forTableColumn:(NSTableColumn *)column row:(NSInteger)row
{
    ivAppGuiParams *guiParams = [ivAppGuiParams instance];
    NSArray *keys = [[guiParams->rStates allKeys] sortedArrayUsingSelector: @selector(compare:)];
    [guiParams->rStates setObject:value forKey:[keys objectAtIndex:row]];
    [tableView reloadData];
}

@end
