//
//  ivOglView+IBActions.h
//  Interactive Videos: Plausible Video Editing using Sparse Structure Points
//
//  Created by Chia-Sheng Chang on 03/01/16.
//  Copyright (c) 2016 Chia-Sheng Chang. All rights reserved.
//

#import "ivOglView.h"

@interface ivOglView (IBActions)

//redraw callback
-(IBAction)redraw:(id)sender;

#pragma mark - View Call Back

//setup animation type
-(IBAction)setupAnimation:(id)sender;

//set scene/object/animation pose
-(IBAction)setScnPose:(id)sender;
-(IBAction)setObjPose:(id)sender;
-(IBAction)setAniPose:(id)sender;

//switch to the scene
-(IBAction)gotoScene:(id)sender;

//modify object list
-(IBAction)addObject:(id)sender;
-(IBAction)rmCurObject:(id)sender;
-(IBAction)duplicateObject:(id)sender;
-(IBAction)nextObject:(id)sender;
-(IBAction)prevObject:(id)sender;

//reset object
-(IBAction)resetObject:(id)sender;

//select frames
-(IBAction)selectFrames:(id)sender;

//process
-(IBAction)process:(id)sender;

#pragma mark - Menu Call Back Render

//set rendering mode
-(IBAction)setRState_Manipulation:(id)sender;
-(IBAction)setRState_Structure:(id)sender;
-(IBAction)setRState_Results:(id)sender;

#pragma mark - Menu Call Back Exporting

// Export: exporting results
-(IBAction)captureImage:(id)sender;
-(IBAction)exportVideo:(id)sender;

@end
