//
//  ivAppData.h
//  Interactive Videos: Plausible Video Editing using Sparse Structure Points
//
//  Created by Chia-Sheng Chang on 03/01/16.
//  Copyright (c) 2016 Chia-Sheng Chang. All rights reserved.
//

#import <Foundation/Foundation.h>

#import "ivDirParams.h"

#import "Utils_Ogl.h"
#import "Utils_DirList.h"

#import "ivAppVideo.h"
#import "ivAppVideoCanny.h"

#include "ivAppSfM.h"
#include "ivAppUsrLabel.h"

#define OSZ_WIDTH 640
#define OSZ_HEIGHT 360

@interface ivAppData : NSObject
{
@public    
    //rendering name/states
    NSMutableDictionary *rStates;
    
    //object video
    ivAppVideo video;
    
    //video edges
    ivAppVideoCanny canny;
    
    //object sfm
    ivAppSfM sfmData;
    
    //user labeling
    ivAppUsrLabel usrLbl;
    
    bool isReady;
}

//read object
-(void) readObject;

//render results
-(void) render;

//frame (max) pose
@property int framePos;
@property int frameMaxPos;

//input video list
@property (retain) NSMutableArray *objectVideos;

//the selected test case
@property (copy) NSString* selectedObject;

//switches
@property BOOL isEdgeSnapping;
@property BOOL isBackFaceCull;

@end

