//
//  ivAppRStates.m
//  Interactive Videos: Plausible Video Editing using Sparse Structure Points
//
//  Created by Chia-Sheng Chang on 03/01/16.
//  Copyright (c) 2016 Chia-Sheng Chang. All rights reserved.
//

#import "ivAppRStates.h"

@implementation ivAppRStates

- (NSInteger)numberOfRowsInTableView:(NSTableView *)tableView
{
    return [_ivad->rStates count];
}

- (id)tableView:(NSTableView *)tableView objectValueForTableColumn:(NSTableColumn *)tableColumn row:(NSInteger)row
{
    NSArray *keys = [[_ivad->rStates allKeys] sortedArrayUsingSelector: @selector(compare:)];

    if ([[tableColumn identifier] isEqualTo:@"name"])
        return [keys objectAtIndex:row];
    else if ([[tableColumn identifier] isEqualTo:@"state"])
        return [_ivad->rStates objectForKey:[keys objectAtIndex:row]];
    
    return 0;
}

- (void)tableView:(NSTableView *)tableView setObjectValue:(id)value forTableColumn:(NSTableColumn *)column row:(NSInteger)row
{
    NSArray *keys = [[_ivad->rStates allKeys] sortedArrayUsingSelector: @selector(compare:)];
    [_ivad->rStates setObject:value forKey:[keys objectAtIndex:row]];
    [tableView reloadData];
}

@end
