//
//  ivOglView.h
//  Interactive Videos: Plausible Video Editing using Sparse Structure Points
//
//  Created by Chia-Sheng Chang on 03/01/16.
//  Copyright (c) 2016 Chia-Sheng Chang. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "ivAppData.h"

#import "Utils_Ocv.h"
#import "Utils_Ogl.h"
#import "Utils_DirList.h"

@interface ivOglView : NSOpenGLView
{

}
//AppData Controller
@property (retain) IBOutlet ivAppData *ivad;

//the ibaction for redrawing
-(IBAction)redraw:(id)sender;

//the ibaction for redrawing
-(IBAction)readObject:(id)sender;

//the ibaction for reset model pose
-(IBAction)resetModelPose:(id)sender;

//read tv model
-(IBAction)readModel:(id)sender;

//export labeled tv model
-(IBAction)exportModel:(id)sender;

//optimize the label points
-(IBAction)doSBA:(id)sender;

//remove prim
-(IBAction)rmPrim:(id)sender;

//remove one ring prims
-(IBAction)rmOneRingPrim:(id)sender;

//switch edge snapping
-(IBAction)switchEdgeSnapping:(id)sender;

//next neighbor prim
-(IBAction)nextNeighborPrim:(id)sender;

//cancel the adjusting
-(IBAction)cancelAdjusting:(id)sender;

//set Critical
-(IBAction)setCritical:(id)sender;

//backface switch
-(IBAction)switchBackFace:(id)sender;

@end
