//
//  ivAppData.h
//  Interactive Videos: Plausible Video Editing using Sparse Structure Points
//
//  Created by Chia-Sheng Chang on 03/01/16.
//  Copyright (c) 2016 Chia-Sheng Chang. All rights reserved.
//

#import <Cocoa/Cocoa.h>

#import "ivDirParams.h"

#import "Utils_Ogl.h"
#import "Utils_Timer.h"
#import "Utils_DirList.h"

#import "ivAppVideo.h"
#import "ivAppStroke.h"
#import "ivAppObjPose.h"
#import "ivAppSfM_SCN.h"
#import "ivAppSfM_OBJ.h"

#define VIDEO_KEY   @"VIDEO"
#define MASK_KEY    @"MASK"
#define STROKE_KEY  @"STROKE"
#define SCENE_KEY   @"SCENE"
#define OBJECT_KEY  @"OBJECT"

#define OSZ_WIDTH 640
#define OSZ_HEIGHT 360

@interface ivAppData : NSObject
{
@public
    //rendering name/states
    NSMutableDictionary *rStates;
    
    //**************************************************
    // Input Data
    //**************************************************
    // Input Video
    ivAppVideo video;
    
    // Input Mask
    ivAppVideo masks;
    
    // User storke
    ivAppStroke stroke;
    
    //Object Pose
    ivAppObjPose objPose;
    
    // scene SfM Data
    ivAppSfM_SCN sfm_scn;
    
    // object SfM Data
    ivAppSfM_OBJ sfm_obj;
    
    bool isReady;
}

//initialization
-(void) reset;

//render results
-(void) render;

@property (retain) NSMutableArray *testCases;
@property (copy) NSString* selectedCase;
@property int framePos;
@property int frameMaxPos;
@property int isStroke;
@property int strokeSize;

@end
