//
//  ivAppDelegate.m
//  Interactive Videos: Plausible Video Editing using Sparse Structure Points
//
//  Created by Chia-Sheng Chang on 03/01/16.
//  Copyright (c) 2016 Chia-Sheng Chang. All rights reserved.
//

#import "ivAppDelegate.h"

@implementation ivAppDelegate

//Termination
- (BOOL)applicationShouldTerminateAfterLastWindowClosed:(NSApplication *)theApplication
{
	return YES;
}

- (void)applicationWillTerminate:(NSNotification *)aNotification
{
    
}

//Enable dragging files on the program
-(void)applicationDidFinishLaunching:(NSNotification*)aNotification
{
    [_oglv registerForDraggedTypes:[NSArray arrayWithObjects:NSFilenamesPboardType, nil]];
}



#pragma mark tableview

- (NSInteger)numberOfRowsInTableView:(NSTableView *)tableView {
    return [_oglv.ivad->rStates count];
}

- (id)tableView:(NSTableView *)tableView objectValueForTableColumn:(NSTableColumn *)tableColumn row:(NSInteger)row {
    NSArray *keys = [_oglv.ivad->rStates allKeys];
    
    if ([[tableColumn identifier] isEqualTo:@"name"])
    {
        return [keys objectAtIndex:row];
    }
    else if ([[tableColumn identifier] isEqualTo:@"state"])
    {
        return [_oglv.ivad->rStates objectForKey:[keys objectAtIndex:row]];
    }

    return 0;
}

- (void)tableView:(NSTableView *)tableView setObjectValue:(id)value forTableColumn:(NSTableColumn *)column row:(NSInteger)row {
    NSArray *keys = [_oglv.ivad->rStates allKeys];
    [_oglv.ivad->rStates setObject:value forKey:[keys objectAtIndex:row]];
    [tableView reloadData];
}

@end
