//
//  ivOglView+Setup.m
//  Interactive Videos: Plausible Video Editing using Sparse Structure Points
//
//  Created by Chia-Sheng Chang on 03/01/16.
//  Copyright (c) 2016 Chia-Sheng Chang. All rights reserved.
//

#import "ivOglView+Setup.h"

@implementation ivOglView (Setup)

//initialization
-(void) awakeFromNib
{
    //set the window as the first responder
    [[self window] setAcceptsMouseMovedEvents:YES];
    [[self window] makeFirstResponder:self];
    
    //keep drawing...
    NSTimer *updateTimer = [NSTimer timerWithTimeInterval:1.0f/30.0f target:self selector:@selector(idle:) userInfo:nil repeats:YES];
    [[NSRunLoop currentRunLoop] addTimer:updateTimer forMode:NSDefaultRunLoopMode];
}

//idle function
- (void)idle:(NSTimer*)timer
{
    [self setNeedsDisplay:YES];
}

//openGL initialization
- (void) prepareOpenGL
{
    Utils_Ogl::InitGL();
}

@end
