//
//  MeanShiftCluster.cpp
//  test
//
//  Created by sulaispig on 2/22/15.
//  Copyright (c) 2015 sulaispig. All rights reserved.
//

#include "MeanShiftCluster.h"

void MeanShiftCluster::cluster
(Eigen::VectorXi &ptClusterIDs, float width, float k_neigh,
 const Eigen::Matrix<float,Eigen::Dynamic,Eigen::Dynamic> &inputPoints)
{
    const int K = 0;
    const int L = 0;
    const int no_lsh = (K<=0) || (L <= 0);
    const int jump=1;
    const double percent=0.0;
    
    //go mean shift clustering
    FAMS cfams(no_lsh);
    
    cfams.LoadPoints(inputPoints);
    cfams.RunFAMS(K, L, k_neigh, percent, jump, width);
    
    //clusters
    Eigen::Matrix<float, Eigen::Dynamic, Eigen::Dynamic> clusters;
    clusters.resize(cfams.npm_, cfams.d_);
    int idx = 0;
    for (int i=0; i<cfams.npm_; i++) for (int j=0; j<cfams.d_; j++)
        clusters(i,j) = cfams.prunedmodes_[idx++]*(cfams.maxVal_-cfams.minVal_)/65535.0 + cfams.minVal_;
    
    //mean shift clustering results
    ptClusterIDs.resize(cfams.nsel_, 1);
    ptClusterIDs.setConstant(-1);
    
    idx = 0;
    //for each points
    for (int i=0; i<cfams.nsel_; i++)
    {
        Eigen::VectorXf curPt;
        curPt.resize(cfams.d_,1);
        for (int j=0; j<cfams.d_; j++)
            curPt(j) = cfams.modes_[idx++]*(cfams.maxVal_-cfams.minVal_)/65535.0 + cfams.minVal_;
        
        int minID = -1;
        float minDist = std::numeric_limits<float>::max();
        //for each valid cluster
        for(int j=0;j<cfams.npm_;j++)
        {
            Eigen::VectorXf c = clusters.row(j).transpose();
            Eigen::VectorXf dist = c - curPt;
            float nDist = dist.norm();
            if( nDist >= width || nDist >= minDist )
                continue;
            
            minDist = nDist;
            minID = j;
        }
        ptClusterIDs(i) = minID;
    }
}