#ifndef __CV_PoissonBlending_EXTRACTED_BY_JS__
#define __CV_PoissonBlending_EXTRACTED_BY_JS__

#include "seamless_cloning.hpp"

namespace PoissonBlending
{
    void seamlessClone( InputArray src, InputArray dst, InputArray mask, cv::Point p,
                                OutputArray blend, int flags);

    void colorChange(InputArray src, InputArray mask, OutputArray dst, float red_mul = 1.0f,
                              float green_mul = 1.0f, float blue_mul = 1.0f);

    void illuminationChange(InputArray src, InputArray mask, OutputArray dst,
                                     float alpha = 0.2f, float beta = 0.4f);

    void textureFlattening(InputArray src, InputArray mask, OutputArray dst,
                                    double low_threshold = 30, double high_threshold = 45,
                                    int kernel_size = 3);
}

#endif
