//
//  Poly2Tri.h
//  Interactive Videos: Plausible Video Editing using Sparse Structure Points
//
//  Created by Chia-Sheng Chang on 03/01/16.
//  Copyright (c) 2016 Chia-Sheng Chang. All rights reserved.
//

#ifndef __test__Poly2Tri__
#define __test__Poly2Tri__

#include "triangle.h"

class DTIO
{
public:
    struct triangulateio ioData;

    DTIO();
    ~DTIO();
    
    void init();
    void release();
    
    friend std::ostream & operator<< (std::ostream &os, const DTIO& obj);
};


class Poly2Tri
{
public:
    //polygon triangulation
    static void execute(const std::vector< Eigen::Vector2f > &points,
                        std::vector< Eigen::Vector3i > &triangles);
};

#endif /* defined(__test__Poly2Tri__) */
