//
//  Utils_Timer.cpp
//  Interactive Videos: Plausible Video Editing using Sparse Structure Points
//
//  Created by Chia-Sheng Chang on 03/01/16.
//  Copyright (c) 2016 Chia-Sheng Chang. All rights reserved.
//

#include "Utils_Timer.h"

void Utils_Timer::start(std::string name)
{
    clock_t t = std::clock();
    this->timeRecords[name] = t;
}


void Utils_Timer::stop(std::string name)
{
    clock_t t = std::clock();
    float elapsedTime = (float)(t-this->timeRecords[name])/CLOCKS_PER_SEC;
    std::cout << name << " takes " << elapsedTime << " seconds" << std::endl;
    this->timeRecords.erase(name);
}


void Utils_Timer::showAll()
{
    std::map<std::string, clock_t>::iterator it;
    
    clock_t t = std::clock();
    
    // show content:
    for (it=timeRecords.begin(); it!=timeRecords.end(); ++it)
    {
        float elapsedTime = (float)(t-it->second)/CLOCKS_PER_SEC;
        std::cout << it->first << " => " << elapsedTime << std::endl;
    }
}