//
//  ivAppAlgorithm.h
//  Interactive Videos: Plausible Video Editing using Sparse Structure Points
//
//  Created by Chia-Sheng Chang on 03/01/16.
//  Copyright (c) 2016 Chia-Sheng Chang. All rights reserved.
//

#ifndef __ivModeling__ivAppAlgorithm__
#define __ivModeling__ivAppAlgorithm__

#import "ivAppData.h"

//interface of algorithms
class ivAppAlgorithm
{
protected:
    //constructor
    ivAppAlgorithm(){}
    
public:
    //destructor
    virtual ~ivAppAlgorithm(){}
    
    //execute the process
    virtual bool execute(ivAppData *ivad) = 0;
    
    //the description of the process
    virtual std::string toString();
};

#endif /* defined(__ivModeling__ivAppAlgorithm__) */
