//
//  ivAppObjPose.h
//  Interactive Videos: Plausible Video Editing using Sparse Structure Points
//
//  Created by Chia-Sheng Chang on 03/01/16.
//  Copyright (c) 2016 Chia-Sheng Chang. All rights reserved.
//

#ifndef __ivManipulation__ivAppObjPose__
#define __ivManipulation__ivAppObjPose__

//the class contain several geometric transformation parameters
class ivAppObjPose
{
public:
    //user specified loacal transform
    Eigen::Vector3f _scl;
    Eigen::Vector3f _trs;
    Eigen::Quaternion<float> _rot;
    
    //constructor
    ivAppObjPose();
    void reset();
    void setFromMatrix( Eigen::Matrix4f m );
    
    //get the transformation
    Eigen::Matrix4f gTransform();
    Eigen::Matrix4f rtTransform();
    
    //interpolation
    ivAppObjPose interpolate(float t,ivAppObjPose &pos);
    
    //operators
    ivAppObjPose operator+(const ivAppObjPose& pose);
    ivAppObjPose operator-(const ivAppObjPose& pose);
    ivAppObjPose operator*(float& scalar);
    
    float magnitude();
    ivAppObjPose normalized();
    
    
    //io
    friend std::istream& operator>>(std::istream& is, ivAppObjPose& pose);
    friend std::ostream& operator<<(std::ostream& os, const ivAppObjPose& pose);
};

#endif /* defined(__ivManipulation__ivAppObjPose__) */
