//
//  ivAppSfM_SCN.h
//  Interactive Videos: Plausible Video Editing using Sparse Structure Points
//
//  Created by sulaispig on 8/29/14.
//  Copyright (c) 2014 nthu. All rights reserved.
//

#ifndef __ivModeling__ivAppSfM_SCN__
#define __ivModeling__ivAppSfM_SCN__

#include "ivDirParams.h"

#include "ivAppSfM.h"

#include "Plane.h"
#include "Utils_Ogl.h"

//read the SfM data in voodoo format (scene)
class ivAppSfM_SCN : public ivAppSfM
{
private:
    //=================================================
    // pre-processing
    //=================================================
    //if the point lies on ground
    std::vector<bool> isPointOnGround;
    
    //transform to ground space
    bool isPlanarMotion;
    void transform2GroundSpace();

    //=================================================
    // Parsing Voodoo
    //=================================================
    //parse camera parameters & Point Cloud
    bool parseCameraParamsPointCloud(std::string tcName);
    
    //parse Point Cloud
    bool parsePointCloud(std::string tcName);

public:
    //=================================================
    // read SfM in voodoo format
    //=================================================
    bool readVoodooSfM(std::string tcName);

    //=================================================
    // Ground Estimation
    //=================================================
    //add/remove ground points
    void collectGroundPoints(int framePos, cv::Mat curStroke, bool isAdd);

    //=================================================
    // Rendering
    //=================================================
    void render( int framePos );
};


#endif /* defined(__ivModeling__ivAppSfM_SCN__) */
