//
//  ivAppGround.cpp
//  Interactive Videos: Plausible Video Editing using Sparse Structure Points
//
//  Created by sulaispig on 7/21/14.
//  Copyright (c) 2014 nthu. All rights reserved.
//

#include "ivAppStroke.h"

//===============================================
// preparing the canvas
//===============================================
void ivAppStroke::init(cv::Size frameSize)
{
    this->frameSize = frameSize;
    this->clear();
}

void ivAppStroke::clear()
{
    this->usrStroke = cv::Mat::zeros( frameSize, CV_8UC4 );
}

//===============================================
// user stroke
//===============================================
void ivAppStroke::draw(int pos)
{
    cv::Point pt( curPoint.x, frameSize.height - 1 - curPoint.y );
    cv::circle(this->usrStroke, pt, strkRadius, cv::Scalar(255,255,255,200), CV_FILLED );
}

//===============================================
// get collected segments and cursor(optional)
//===============================================
cv::Mat ivAppStroke::getCurStroke()
{
    cv::Mat tmp = this->usrStroke.clone();
    
    cv::Point pt( curPoint.x, frameSize.height - 1 - curPoint.y );
    cv::circle(tmp, pt, (int)strkRadius, cv::Scalar(255,255,255,200), CV_FILLED );
    
    return tmp;
}
cv::Mat ivAppStroke::getBinaryStroke()
{
    cv::Mat tmp = this->usrStroke.clone();
    
    std::vector<cv::Mat> rgba;
    cv::split(tmp, rgba);
    
    return rgba[0].clone();
}

