//
//  ivAppGround.h
//  Interactive Videos: Plausible Video Editing using Sparse Structure Points
//
//  Created by sulaispig on 7/21/14.
//  Copyright (c) 2014 nthu. All rights reserved.
//

#ifndef __ivModeling__ivAppStroke__
#define __ivModeling__ivAppStroke__

#include "ivAppVideo.h"

class ivAppStroke
{
private:
    cv::Size frameSize;
    cv::Mat usrStroke;
    
public:
    //current mouse cursor and stroke radius
    cv::Point curPoint;
    int strkRadius;
    
    //===============================================
    // constructor and destructor
    //===============================================
    ivAppStroke():strkRadius(30),curPoint(-100,-100){}
    ~ivAppStroke(){}
    
    //===============================================
    // preparing the canvas
    //===============================================
    void init(cv::Size frameSize);
    void clear();

    //===============================================
    // user stroke
    //===============================================
    void draw(int pos);
    
    //===============================================
    // get collected segments and curor(optional)
    //===============================================
    cv::Mat getCurStroke();
    cv::Mat getBinaryStroke();
};

#endif /* defined(__ivModeling__ivAppGround__) */
