//
//  ivAppVideo.h
//  Interactive Videos: Plausible Video Editing using Sparse Structure Points
//
//  Created by Chia-Sheng Chang on 03/01/16.
//  Copyright (c) 2016 Chia-Sheng Chang. All rights reserved.
//

#ifndef __ivModeling__ivAppVideo__
#define __ivModeling__ivAppVideo__

//this class process the video input
class ivAppVideo
{
public:
    //if the video is ready
    bool isReady;
    
	//cache the video in the memory
    std::vector<cv::Mat>   frames;
	cv::Size              frameSz;
	int                  frameNum;
    
    //=================================================
	// read the video name inputVideo
	//=================================================
    bool readVideo(std::string inputVideo, int bufSize=60);
    
    //=================================================
    // calc mean luminance
    //=================================================
    std::vector<cv::Scalar> meanLuminance;
    void calcMeanLuminance(bool useBilateralFilter=false);
};

#endif /* defined(__ivModeling__ivAppVideo__) */
