//
//  ivAppVideoCanny.h
//  Interactive Videos: Plausible Video Editing using Sparse Structure Points
//
//  Created by Chia-Sheng Chang on 03/01/16.
//  Copyright (c) 2016 Chia-Sheng Chang. All rights reserved.
//

#ifndef __ivModeling__ivAppVideoCanny__
#define __ivModeling__ivAppVideoCanny__

#include "ivAppVideo.h"

class ivAppVideoCanny
{
public:
    //if the video is ready
    bool isReady;
    
    //cache the video in the memory
    std::vector<cv::Mat> edges;
    cv::Size           frameSz;
    int               frameNum;
    
    //calculate canny edges
    bool init(ivAppVideo *vi);
    
    //rendering the edge
    cv::Mat getAlphaEdge(int framePos);
};

#endif /* defined(__ivModeling__ivAppVideoCanny__) */
