//
//  ivAppVideoEdges.h
//  Interactive Videos: Plausible Video Editing using Sparse Structure Points
//
//  Created by sulaispig on 12/6/14.
//  Copyright (c) 2014 sulaispig. All rights reserved.
//

#ifndef __ivModeling__ivAppVideoEdges__
#define __ivModeling__ivAppVideoEdges__

#include "ivAppVideo.h"
#include "CmCurveEx.h"

//the edges found in a frame
class FrameEdges
{
public:
    FrameEdges(cv::Mat &img);
    std::vector< CmCurveEx::CEdge > edges;
    
    //draw related line in ROI
    cv::Mat drawInROI(cv::Mat &roiMsk,
                      cv::Rect roi,
                      cv::Point orient,
                      int lineLen,
                      float angle,
                      float lenRatio   );
};

class ivAppVideoEdges
{
private:
    //video edges
    std::vector< FrameEdges* > ves;
    
public:
    
    ~ivAppVideoEdges();
    
    void init(ivAppVideo *vi);
    void clear();
    
    //get the edges of the frame pos
    FrameEdges* getFrameEdges( int pos );
    
    //render the edges
    void renderEdges(cv::Mat &drawing, int pos);
    
    
};

#endif /* defined(__ivModeling__ivAppVideoEdges__) */
