//
//  ivAppTvEdges.h
//  Interactive Videos: Plausible Video Editing using Sparse Structure Points
//
//  Created by Chia-Sheng Chang on 03/01/16.
//  Copyright (c) 2016 Chia-Sheng Chang. All rights reserved.
//

#ifndef __ivManipulation__ivAppTvEdges__
#define __ivManipulation__ivAppTvEdges__

#include "ivAppTvModelData.h"
#include "ivAppVideo.h"
#include "ivAppSfM.h"

class tvEdge
{
public:
    // vertex index
    Eigen::Vector2i vids;
    
    //if the edge is visible in the object video
    std::vector<bool> isVisible;
};

class ivAppTvEdges : public ivAppTvModelData
{
public:    
    // all of the tv edges in the tv model
    std::vector< tvEdge > vtvEdge;

    //tv model input
    void readTVModel(std::string fileName, ivAppSfM *sfmData);
};

#endif /* defined(__ivManipulation__ivAppTvEdges__) */
